package examples.adt;

/**
 * Interface specifying a Queue ADT.
 *
 * @author Grant Braught, revisions by Farhan Siddiqui
 * @author Dickinson College
 * @version Aug 10, 2019
 */
public interface CS132Queue {
    
    /**
     * Add the provided Object to the end of the Queue.
     * 
     * @param obj the Object to add to the queue
     */
    public void add(Object obj);
    
    /**
     * Remove and return the Object at the head of the Queue.
     * 
     * @return the Object at the head of the Queue or null
     * if the Queue is empty.
     */
    public Object remove();
    
    /**
     * Return a reference to the Object at the head of the Queue without 
     * removing it from the Queue.
     * 
     * @return a reference to the Object at the head of the Queue or
     * null if the Queue is empty.
     */
    public Object peek();
    
    /**
     * Return the number of elements in the Queue.
     * 
     * @return the size of the Queue.
     */
    public int size();
}
